package com.example.demo;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

public abstract class People <PersonType extends Person> implements Iterable<PersonType>{
     List<PersonType> personList;

    public People(Person ... people) {
       this.personList = new ArrayList(Arrays.asList(people));

    }

    public People() {

        this.personList = new ArrayList<>();
    }

    public void add(PersonType person){
        personList.add(person);
    }
    public void remove(PersonType person){
        personList.remove(person);
    }
    public int size(){

        return personList.size();
    }
    public void clear(){
        personList.clear();
    }
    public void addAll(Iterable<PersonType> personTypeIterable){
        for (PersonType person:personTypeIterable) {
            personList.add(person);
        }

    }
    public PersonType findById(Long id){
        for (PersonType person: personList) {
            if (person.getId() == id){
                return person;
            }
        }
        return null;
    }
    public List<PersonType> findAll(){
        return personList;
    }


    @Override
    public Iterator<PersonType> iterator() {
        return personList.iterator();
    }
}
